Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 11200)
+++ trunk/FACT++/gui/FactGui.h	(revision 11207)
@@ -385,5 +385,4 @@
     DimStampedInfo fDimFadRuns;
     DimStampedInfo fDimFadEvents;
-    DimStampedInfo fDimFadCurrentEvent;
     DimStampedInfo fDimFadEventData;
     DimStampedInfo fDimFadConnections;
@@ -391,4 +390,5 @@
     DimStampedInfo fDimFadRunNumber;
     DimStampedInfo fDimFadDNA;
+    DimStampedInfo fDimFadTemperature;
     DimStampedInfo fDimFadStatus;
     DimStampedInfo fDimFadStatistics;
@@ -932,17 +932,20 @@
     void handleFadRuns(const DimData &d)
     {
-        if (!CheckSize(d, 12))
+        if (!CheckSize(d, 20))
             return;
 
         const uint32_t *ptr = d.ptr<uint32_t>();
 
+        fEvtBldOpenFiles->setValue(ptr[0]);
+        fEvtBldOpenStreams->setValue(ptr[0]);
         fEvtBldRunNumberMin->setValue(ptr[1]);
         fEvtBldRunNumberMax->setValue(ptr[2]);
-        fEvtBldOpenFiles->setValue(ptr[0]);
+        fEvtBldLastOpened->setValue(ptr[3]);
+        fEvtBldLastClosed->setValue(ptr[4]);
     }
 
     void handleFadEvents(const DimData &d)
     {
-        if (!CheckSize(d, 8))
+        if (!CheckSize(d, 16))
             return;
 
@@ -951,12 +954,30 @@
         fEvtsSuccessCurRun->setValue(ptr[0]);
         fEvtsSuccessTotal->setValue(ptr[1]);
-    }
-
-    void handleFadCurrentEvent(const DimData &d)
-    {
-        if (!CheckSize(d, 4))
-            return;
-
-        fEvtsEventId->setValue(d.get<uint32_t>());
+        fEvtBldEventId->setValue(ptr[2]);
+        fEvtBldTriggerId->setValue(ptr[3]);
+    }
+
+    void handleFadTemperature(const DimData &d)
+    {
+        if (d.size()==0)
+        {
+            fFadTempMin->setEnabled(false);
+            fFadTempMax->setEnabled(false);
+            return;
+        }
+
+        if (!CheckSize(d, 82*sizeof(float)))
+            return;
+
+        const float *ptr = d.ptr<float>();
+
+        fFadTempMin->setEnabled(true);
+        fFadTempMax->setEnabled(true);
+
+        fFadTempMin->setValue(ptr[0]);
+        fFadTempMax->setValue(ptr[40]);
+
+        handleFadToolTip(d.time, fFadTempMin, ptr+1);
+        handleFadToolTip(d.time, fFadTempMax, ptr+41);
     }
 
@@ -1039,5 +1060,5 @@
     }
 
-    vector<uint8_t> fFadConnections;
+//    vector<uint8_t> fFadConnections;
 
     void handleFadConnections(const DimData &d)
@@ -1070,7 +1091,35 @@
         }
 
-        SetLedColor(fFadLEDEventBuilder, ptr[40]==0?kLedRed:kLedGreen, d.time);
-
-        fFadConnections.assign(ptr, ptr+40);
+
+        const bool runs = ptr[40]!=0;
+
+        fStatusEventBuilderLabel->setText(runs?"Running":"Not running");
+        fStatusEventBuilderLabel->setToolTip(runs?"Event builder thread running.":"Event builder thread stopped.");
+        fEvtBldWidget->setEnabled(runs);
+
+        SetLedColor(fStatusEventBuilderLed, runs?kLedGreen:kLedRed, d.time);
+
+//        fFadConnections.assign(ptr, ptr+40);
+    }
+
+    template<typename T>
+        void handleFadToolTip(const Time &time, QWidget *w, T *ptr)
+    {
+        ostringstream tip;
+        tip << "<table border='1'><tr><th colspan='11'>" << time.GetAsStr() << " (UTC)</th></tr><tr><th></th>";
+        for (int b=0; b<10; b++)
+            tip << "<th>" << b << "</th>";
+        tip << "</tr>";
+
+        for (int c=0; c<4; c++)
+        {
+            tip << "<tr><th>" << c << "</th>";
+            for (int b=0; b<10; b++)
+                tip << "<td>" << ptr[c*10+b] << "</td>";
+            tip << "</tr>";
+        }
+        tip << "</table>";
+
+        w->setToolTip(tip.str().c_str());
     }
 
@@ -1098,20 +1147,5 @@
             wmax->setValue(max);
 
-        ostringstream tip;
-        tip << "<table border='1'><tr><th colspan='11'>" << Time().GetAsStr() << " (UTC)</th></tr><tr><th></th>";
-        for (int b=0; b<10; b++)
-            tip << "<th>" << b << "</th>";
-        tip << "</tr>";
-
-        for (int c=0; c<4; c++)
-        {
-            tip << "<tr><th>" << c << "</th>";
-            for (int b=0; b<10; b++)
-                tip << "<td>" << ptr[c*10+b] << "</td>";
-            tip << "</tr>";
-        }
-        tip << "</table>";
-
-        led->setToolTip(tip.str().c_str());
+        handleFadToolTip(d.time, led, ptr);
     }
 
@@ -1152,11 +1186,17 @@
     }
 
-    void SetFadLed(QPushButton *led, const DimData &d, uint16_t bitmask)
-    {
+    void SetFadLed(QPushButton *led, const DimData &d, uint16_t bitmask, bool invert=false)
+    {
+        if (d.size()==0)
+        {
+            SetLedColor(led, kLedGray, d.time);
+            return;
+        }
+
         const bool      quality = d.ptr<uint16_t>()[0]&bitmask;
         const bool      value   = d.ptr<uint16_t>()[1]&bitmask;
         const uint16_t *ptr     = d.ptr<uint16_t>()+2;
 
-        SetLedColor(led, quality?kLedOrange:(value?kLedGreen:kLedRed), d.time);
+        SetLedColor(led, quality?kLedOrange:(value^invert?kLedGreen:kLedRed), d.time);
 
         ostringstream tip;
@@ -1184,5 +1224,5 @@
     void handleFadStatus(const DimData &d)
     {
-        if (!CheckSize(d, 42*sizeof(uint16_t)))
+        if (d.size()!=0 && !CheckSize(d, 42*sizeof(uint16_t)))
             return;
 
@@ -1192,5 +1232,5 @@
         SetFadLed(fFadLedDcmReady,       d, FAD::EventHeader::kDcmReady);
         SetFadLed(fFadLedSpiSclk,        d, FAD::EventHeader::kSpiSclk);
-        SetFadLed(fFadLedRefClockTooLow, d, FAD::EventHeader::kRefClkTooLow);
+        SetFadLed(fFadLedRefClockTooLow, d, FAD::EventHeader::kRefClkTooLow, true);
         SetFadLed(fFadLedBusy,           d, FAD::EventHeader::kBusy);
         SetFadLed(fFadLedTriggerLine,    d, FAD::EventHeader::kTriggerLine);
@@ -1215,5 +1255,6 @@
         fFadEvtDel->setValue(stat[3]);
         fFadEvtTot->setValue(stat[4]);
-        fFadEvtRead->setValue(stat[6]/1024.);
+        fFadEthernetRateTot->setValue(stat[6]/1024.);
+        fFadEthernetRateAvg->setValue(stat[6]/1024./stat[7]);
         fFadEvtConn->setValue(stat[7]);
     }
@@ -1735,6 +1776,14 @@
             bool enable = false;
 
-            if (s.index<FAD::kDisconnected) // No Dim connection
+            if (s.index<FAD::kOffline) // No Dim connection
+            {
                 SetLedColor(fStatusFADLed, kLedGray, time);
+
+                fStatusEventBuilderLabel->setText("Offline");
+                fStatusEventBuilderLabel->setToolTip("No connection to fadctrl.");
+                fEvtBldWidget->setEnabled(false);
+
+                SetLedColor(fStatusEventBuilderLed, kLedGray, time);
+            }
             if (s.index==FAD::kOffline) // Dim connection / FTM disconnected
                 SetLedColor(fStatusFADLed, kLedRed, time);
@@ -2013,4 +2062,7 @@
             return PostInfoHandler(&FactGui::handleFadDNA);
 
+        if (getInfo()==&fDimFadTemperature)
+            return PostInfoHandler(&FactGui::handleFadTemperature);
+
         if (getInfo()==&fDimFadStatus)
             return PostInfoHandler(&FactGui::handleFadStatus);
@@ -2024,7 +2076,4 @@
         if (getInfo()==&fDimFadRuns)
             return PostInfoHandler(&FactGui::handleFadRuns);
-
-        if (getInfo()==&fDimFadCurrentEvent)
-            return PostInfoHandler(&FactGui::handleFadCurrentEvent);
 
 	if (getInfo()==&fDimFadEventData)
@@ -2437,10 +2486,10 @@
         fInChoosePatch(false), 
         fDimDNS("DIS_DNS/VERSION_NUMBER", 1, int(0), this),
-
+        //-
         fDimLoggerStats        ("DATA_LOGGER/STATS",            (void*)NULL, 0, this),
         fDimLoggerFilenameNight("DATA_LOGGER/FILENAME_NIGHTLY", (void*)NULL, 0, this),
         fDimLoggerFilenameRun  ("DATA_LOGGER/FILENAME_RUN",     (void*)NULL, 0, this),
         fDimLoggerNumSubs      ("DATA_LOGGER/NUM_SUBS",         (void*)NULL, 0, this),
-
+        //-
         fDimFtmPassport        ("FTM_CONTROL/PASSPORT",         (void*)NULL, 0, this),
         fDimFtmTriggerCounter  ("FTM_CONTROL/TRIGGER_COUNTER",  (void*)NULL, 0, this),
@@ -2450,7 +2499,7 @@
         fDimFtmDynamicData     ("FTM_CONTROL/DYNAMIC_DATA",     (void*)NULL, 0, this),
         fDimFtmCounter         ("FTM_CONTROL/COUNTER",          (void*)NULL, 0, this),
+        //-
         fDimFadRuns            ("FAD_CONTROL/RUNS",             (void*)NULL, 0, this),
         fDimFadEvents          ("FAD_CONTROL/EVENTS",           (void*)NULL, 0, this),
-        fDimFadCurrentEvent    ("FAD_CONTROL/CURRENT_EVENT",    (void*)NULL, 0, this),
         fDimFadEventData       ("FAD_CONTROL/EVENT_DATA",       (void*)NULL, 0, this),
         fDimFadConnections     ("FAD_CONTROL/CONNECTIONS",      (void*)NULL, 0, this),
@@ -2458,4 +2507,5 @@
         fDimFadRunNumber       ("FAD_CONTROL/RUN_NUMBER",       (void*)NULL, 0, this),
         fDimFadDNA             ("FAD_CONTROL/DNA",              (void*)NULL, 0, this),
+        fDimFadTemperature     ("FAD_CONTROL/TEMPERATURE",      (void*)NULL, 0, this),
         fDimFadStatus          ("FAD_CONTROL/STATUS",           (void*)NULL, 0, this),
         fDimFadStatistics      ("FAD_CONTROL/STATISTICS",       (void*)NULL, 0, this)
Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11200)
+++ trunk/FACT++/gui/design.ui	(revision 11207)
@@ -53,5 +53,5 @@
       </property>
       <property name="currentIndex">
-       <number>4</number>
+       <number>3</number>
       </property>
       <property name="documentMode">
@@ -2869,5 +2869,5 @@
        </layout>
       </widget>
-      <widget class="QWidget" name="fFADTab">
+      <widget class="QWidget" name="fFadTab">
        <attribute name="title">
         <string>FAD</string>
@@ -3101,49 +3101,4 @@
                </item>
               </layout>
-             </item>
-             <item row="2" column="1">
-              <widget class="QLabel" name="label_138">
-               <property name="text">
-                <string>Event Builder thread running</string>
-               </property>
-              </widget>
-             </item>
-             <item row="2" column="0">
-              <widget class="QPushButton" name="fFadLEDEventBuilder">
-               <property name="enabled">
-                <bool>true</bool>
-               </property>
-               <property name="sizePolicy">
-                <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-                 <horstretch>0</horstretch>
-                 <verstretch>0</verstretch>
-                </sizepolicy>
-               </property>
-               <property name="maximumSize">
-                <size>
-                 <width>18</width>
-                 <height>16777215</height>
-                </size>
-               </property>
-               <property name="text">
-                <string/>
-               </property>
-               <property name="icon">
-                <iconset resource="design.qrc">
-                 <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-               </property>
-               <property name="iconSize">
-                <size>
-                 <width>16</width>
-                 <height>16</height>
-                </size>
-               </property>
-               <property name="checkable">
-                <bool>false</bool>
-               </property>
-               <property name="flat">
-                <bool>true</bool>
-               </property>
-              </widget>
              </item>
             </layout>
@@ -3246,5 +3201,5 @@
             <layout class="QGridLayout" name="gridLayout_42">
              <item row="0" column="0">
-              <layout class="QGridLayout" name="gridLayout_37" rowstretch="0,0,0,0,0,0,0,0,0,0,0,0,0,0">
+              <layout class="QGridLayout" name="gridLayout_37" rowstretch="0,0,0,0,0,0,0,0,0,0">
                <item row="1" column="1">
                 <widget class="QPushButton" name="fFadTriggerLineOn">
@@ -4010,4 +3965,7 @@
                <item row="2" column="2">
                 <widget class="QSpinBox" name="spinBox">
+                 <property name="enabled">
+                  <bool>false</bool>
+                 </property>
                  <property name="alignment">
                   <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4023,4 +3981,7 @@
                <item row="3" column="2">
                 <widget class="QSpinBox" name="spinBox_2">
+                 <property name="enabled">
+                  <bool>false</bool>
+                 </property>
                  <property name="alignment">
                   <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4052,4 +4013,7 @@
                <item row="4" column="2">
                 <widget class="QSpinBox" name="spinBox_3">
+                 <property name="enabled">
+                  <bool>false</bool>
+                 </property>
                  <property name="alignment">
                   <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4103,4 +4067,7 @@
                <item row="2" column="3">
                 <widget class="QSpinBox" name="spinBox_18">
+                 <property name="enabled">
+                  <bool>false</bool>
+                 </property>
                  <property name="alignment">
                   <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4120,4 +4087,7 @@
                <item row="4" column="3">
                 <widget class="QSpinBox" name="spinBox_20">
+                 <property name="enabled">
+                  <bool>false</bool>
+                 </property>
                  <property name="alignment">
                   <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4171,5 +4141,5 @@
                </item>
                <item row="9" column="2">
-                <widget class="QDoubleSpinBox" name="doubleSpinBox_2">
+                <widget class="QDoubleSpinBox" name="fFadTempMin">
                  <property name="alignment">
                   <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4184,5 +4154,5 @@
                </item>
                <item row="9" column="3">
-                <widget class="QDoubleSpinBox" name="doubleSpinBox_3">
+                <widget class="QDoubleSpinBox" name="fFadTempMax">
                  <property name="alignment">
                   <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4296,5 +4266,5 @@
                  </property>
                  <property name="maximum">
-                  <number>999999999</number>
+                  <number>2147483647</number>
                  </property>
                 </widget>
@@ -4344,5 +4314,5 @@
                  </property>
                  <property name="maximum">
-                  <number>999999999</number>
+                  <number>2147483647</number>
                  </property>
                 </widget>
@@ -4376,5 +4346,5 @@
            <string>Event Builder overview</string>
           </property>
-          <widget class="QWidget" name="fAdcWidget">
+          <widget class="QWidget" name="fEvtBldWidget">
            <property name="sizePolicy">
             <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
@@ -4386,15 +4356,616 @@
             <item row="0" column="0">
              <layout class="QGridLayout" name="gridLayout_47">
-              <item row="1" column="1">
-               <widget class="QGroupBox" name="groupBox_15">
+              <item row="0" column="1">
+               <widget class="QGroupBox" name="groupBox_16">
                 <property name="title">
-                 <string>Closed files</string>
-                </property>
-                <widget class="QWidget" name="gridLayoutWidget_7">
+                 <string>Open output streams</string>
+                </property>
+                <widget class="QWidget" name="gridLayoutWidget_5">
+                 <property name="geometry">
+                  <rect>
+                   <x>10</x>
+                   <y>30</y>
+                   <width>441</width>
+                   <height>206</height>
+                  </rect>
+                 </property>
+                 <layout class="QGridLayout" name="gridLayout_50">
+                  <item row="1" column="1">
+                   <widget class="QLabel" name="label_110">
+                    <property name="text">
+                     <string>Run no.</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="0" column="0">
+                   <widget class="QLabel" name="label_127">
+                    <property name="text">
+                     <string>No. streams</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="0" column="1">
+                   <widget class="QSpinBox" name="fEvtBldOpenStreams">
+                    <property name="alignment">
+                     <set>Qt::AlignCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="2" column="1">
+                   <widget class="QSpinBox" name="fEvtBldRunNumberMin">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="1">
+                   <widget class="QSpinBox" name="fEvtBldRunNumberMax">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="2" column="0">
+                   <widget class="QLabel" name="label_107">
+                    <property name="text">
+                     <string>Min</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="0">
+                   <widget class="QLabel" name="label_112">
+                    <property name="text">
+                     <string>Max</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="1">
+                   <widget class="QLabel" name="label_120">
+                    <property name="text">
+                     <string>Last run no.</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="5" column="1">
+                   <widget class="QSpinBox" name="fEvtBldLastOpened">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="6" column="1">
+                   <widget class="QSpinBox" name="fEvtBldLastClosed">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="5" column="0">
+                   <widget class="QLabel" name="label_125">
+                    <property name="text">
+                     <string>Opened</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="6" column="0">
+                   <widget class="QLabel" name="label_126">
+                    <property name="text">
+                     <string>Closed</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="2" column="4">
+                   <widget class="QLabel" name="label_98">
+                    <property name="text">
+                     <string>For max run no.</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="4">
+                   <widget class="QSpinBox" name="fEvtBldEventId">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="4">
+                   <widget class="QSpinBox" name="fEvtBldTriggerId">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="3">
+                   <widget class="QLabel" name="label_109">
+                    <property name="text">
+                     <string>Event ID</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="3">
+                   <widget class="QLabel" name="label_108">
+                    <property name="text">
+                     <string>Trigger ID</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="2">
+                   <widget class="QLabel" name="label_146">
+                    <property name="text">
+                     <string>------&gt;</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="2">
+                   <widget class="QLabel" name="label_147">
+                    <property name="text">
+                     <string> \----&gt;</string>
+                    </property>
+                   </widget>
+                  </item>
+                 </layout>
+                </widget>
+               </widget>
+              </item>
+              <item row="0" column="0">
+               <widget class="QGroupBox" name="groupBox_17">
+                <property name="title">
+                 <string>Ethernet</string>
+                </property>
+                <widget class="QWidget" name="gridLayoutWidget_6">
                  <property name="geometry">
                   <rect>
                    <x>110</x>
                    <y>60</y>
-                   <width>250</width>
+                   <width>263</width>
+                   <height>141</height>
+                  </rect>
+                 </property>
+                 <layout class="QGridLayout" name="gridLayout_48" columnstretch="0,0,0,0,0,0">
+                  <item row="4" column="3">
+                   <widget class="QDoubleSpinBox" name="fFadEthernetRateAvg">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> kB/s</string>
+                    </property>
+                    <property name="decimals">
+                     <number>1</number>
+                    </property>
+                    <property name="maximum">
+                     <double>10000.000000000000000</double>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="3">
+                   <widget class="QDoubleSpinBox" name="fFadEthernetRateMin">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> kB/s</string>
+                    </property>
+                    <property name="decimals">
+                     <number>1</number>
+                    </property>
+                    <property name="maximum">
+                     <double>10000.000000000000000</double>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="5" column="3">
+                   <widget class="QDoubleSpinBox" name="fFadEthernetRateMax">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> kB/s</string>
+                    </property>
+                    <property name="decimals">
+                     <number>1</number>
+                    </property>
+                    <property name="maximum">
+                     <double>10000.000000000000000</double>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="2" column="3">
+                   <widget class="QLabel" name="label_117">
+                    <property name="text">
+                     <string>Per socket</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignBottom|Qt::AlignHCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="4">
+                   <widget class="QLabel" name="label_123">
+                    <property name="text">
+                     <string>Total</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignBottom|Qt::AlignHCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="4">
+                   <widget class="QSpinBox" name="fFadEthernetRateTot">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> kB/s</string>
+                    </property>
+                    <property name="maximum">
+                     <number>1000000</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="2">
+                   <widget class="QLabel" name="label_118">
+                    <property name="text">
+                     <string>Min</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="2">
+                   <widget class="QLabel" name="label_119">
+                    <property name="text">
+                     <string>Avg</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="5" column="2">
+                   <widget class="QLabel" name="label_122">
+                    <property name="text">
+                     <string>Max</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="0" column="3">
+                   <widget class="QSpinBox" name="fFadEvtConn">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> sockets</string>
+                    </property>
+                    <property name="maximum">
+                     <number>1000</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="1" column="3">
+                   <spacer name="verticalSpacer_25">
+                    <property name="orientation">
+                     <enum>Qt::Vertical</enum>
+                    </property>
+                    <property name="sizeHint" stdset="0">
+                     <size>
+                      <width>20</width>
+                      <height>40</height>
+                     </size>
+                    </property>
+                   </spacer>
+                  </item>
+                 </layout>
+                </widget>
+               </widget>
+              </item>
+              <item row="1" column="0">
+               <widget class="QGroupBox" name="groupBox_18">
+                <property name="title">
+                 <string>Memory</string>
+                </property>
+                <widget class="QWidget" name="gridLayoutWidget_4">
+                 <property name="geometry">
+                  <rect>
+                   <x>100</x>
+                   <y>40</y>
+                   <width>281</width>
+                   <height>191</height>
+                  </rect>
+                 </property>
+                 <layout class="QGridLayout" name="gridLayout_49">
+                  <item row="0" column="1">
+                   <widget class="QSpinBox" name="fFadBufferMax">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> MB</string>
+                    </property>
+                    <property name="maximum">
+                     <number>1000000</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="1" column="0" colspan="2">
+                   <widget class="QProgressBar" name="fFadBuffer">
+                    <property name="value">
+                     <number>24</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="0" column="0">
+                   <widget class="QLabel" name="label_105">
+                    <property name="text">
+                     <string>Maximum buffer size</string>
+                    </property>
+                    <property name="alignment">
+                     <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter</set>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="1">
+                   <widget class="QSpinBox" name="fFadEvtSkip">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> evts</string>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="1">
+                   <widget class="QSpinBox" name="fFadEvtWait">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> evts</string>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="4" column="0">
+                   <widget class="QLabel" name="label_139">
+                    <property name="text">
+                     <string>Closed in buffer</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="3" column="0">
+                   <widget class="QLabel" name="label_140">
+                    <property name="text">
+                     <string>Partially in buffer</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="2" column="0">
+                   <spacer name="verticalSpacer_30">
+                    <property name="orientation">
+                     <enum>Qt::Vertical</enum>
+                    </property>
+                    <property name="sizeHint" stdset="0">
+                     <size>
+                      <width>20</width>
+                      <height>40</height>
+                     </size>
+                    </property>
+                   </spacer>
+                  </item>
+                  <item row="5" column="0">
+                   <spacer name="verticalSpacer_29">
+                    <property name="orientation">
+                     <enum>Qt::Vertical</enum>
+                    </property>
+                    <property name="sizeHint" stdset="0">
+                     <size>
+                      <width>20</width>
+                      <height>40</height>
+                     </size>
+                    </property>
+                   </spacer>
+                  </item>
+                  <item row="6" column="0">
+                   <widget class="QLabel" name="label_142">
+                    <property name="text">
+                     <string>Released from buffer</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="7" column="0">
+                   <widget class="QLabel" name="label_141">
+                    <property name="text">
+                     <string>Event release rate</string>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="6" column="1">
+                   <widget class="QSpinBox" name="fFadEvtTot">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> evts</string>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                  <item row="7" column="1">
+                   <widget class="QSpinBox" name="fFadEvtDel">
+                    <property name="alignment">
+                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                    </property>
+                    <property name="readOnly">
+                     <bool>true</bool>
+                    </property>
+                    <property name="buttonSymbols">
+                     <enum>QAbstractSpinBox::NoButtons</enum>
+                    </property>
+                    <property name="suffix">
+                     <string> evt/s</string>
+                    </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
+                   </widget>
+                  </item>
+                 </layout>
+                </widget>
+               </widget>
+              </item>
+              <item row="1" column="1">
+               <widget class="QGroupBox" name="groupBox_15">
+                <property name="title">
+                 <string>Output stream with maximum run no.</string>
+                </property>
+                <widget class="QWidget" name="gridLayoutWidget_7">
+                 <property name="geometry">
+                  <rect>
+                   <x>100</x>
+                   <y>80</y>
+                   <width>298</width>
                    <height>104</height>
                   </rect>
@@ -4434,5 +5005,5 @@
                     </property>
                     <property name="maximum">
-                     <number>1000000</number>
+                     <number>2147483647</number>
                     </property>
                    </widget>
@@ -4449,4 +5020,7 @@
                      <enum>QAbstractSpinBox::NoButtons</enum>
                     </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
                    </widget>
                   </item>
@@ -4462,4 +5036,7 @@
                      <enum>QAbstractSpinBox::NoButtons</enum>
                     </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
                    </widget>
                   </item>
@@ -4490,5 +5067,5 @@
                     </property>
                     <property name="maximum">
-                     <number>1000000</number>
+                     <number>2147483647</number>
                     </property>
                    </widget>
@@ -4505,4 +5082,7 @@
                      <enum>QAbstractSpinBox::NoButtons</enum>
                     </property>
+                    <property name="maximum">
+                     <number>2147483647</number>
+                    </property>
                    </widget>
                   </item>
@@ -4518,533 +5098,6 @@
                      <enum>QAbstractSpinBox::NoButtons</enum>
                     </property>
-                   </widget>
-                  </item>
-                 </layout>
-                </widget>
-               </widget>
-              </item>
-              <item row="0" column="1">
-               <widget class="QGroupBox" name="groupBox_16">
-                <property name="title">
-                 <string>Open files</string>
-                </property>
-                <widget class="QWidget" name="gridLayoutWidget_5">
-                 <property name="geometry">
-                  <rect>
-                   <x>80</x>
-                   <y>80</y>
-                   <width>309</width>
-                   <height>101</height>
-                  </rect>
-                 </property>
-                 <layout class="QGridLayout" name="gridLayout_50">
-                  <item row="1" column="0">
-                   <widget class="QLabel" name="label_98">
-                    <property name="text">
-                     <string>Run number</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="0">
-                   <widget class="QLabel" name="label_108">
-                    <property name="text">
-                     <string>Trigger ID</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="0">
-                   <widget class="QLabel" name="label_109">
-                    <property name="text">
-                     <string>Event ID</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="1">
-                   <widget class="QPushButton" name="fStatusDNSLed_8">
-                    <property name="enabled">
-                     <bool>true</bool>
-                    </property>
-                    <property name="sizePolicy">
-                     <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-                      <horstretch>0</horstretch>
-                      <verstretch>0</verstretch>
-                     </sizepolicy>
-                    </property>
-                    <property name="maximumSize">
-                     <size>
-                      <width>18</width>
-                      <height>16777215</height>
-                     </size>
-                    </property>
-                    <property name="text">
-                     <string/>
-                    </property>
-                    <property name="icon">
-                     <iconset resource="design.qrc">
-                      <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-                    </property>
-                    <property name="iconSize">
-                     <size>
-                      <width>16</width>
-                      <height>16</height>
-                     </size>
-                    </property>
-                    <property name="checkable">
-                     <bool>false</bool>
-                    </property>
-                    <property name="flat">
-                     <bool>true</bool>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="1">
-                   <widget class="QPushButton" name="fStatusDNSLed_9">
-                    <property name="enabled">
-                     <bool>true</bool>
-                    </property>
-                    <property name="sizePolicy">
-                     <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-                      <horstretch>0</horstretch>
-                      <verstretch>0</verstretch>
-                     </sizepolicy>
-                    </property>
-                    <property name="maximumSize">
-                     <size>
-                      <width>18</width>
-                      <height>16777215</height>
-                     </size>
-                    </property>
-                    <property name="text">
-                     <string/>
-                    </property>
-                    <property name="icon">
-                     <iconset resource="design.qrc">
-                      <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-                    </property>
-                    <property name="iconSize">
-                     <size>
-                      <width>16</width>
-                      <height>16</height>
-                     </size>
-                    </property>
-                    <property name="checkable">
-                     <bool>false</bool>
-                    </property>
-                    <property name="flat">
-                     <bool>true</bool>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="1" column="2">
-                   <widget class="QSpinBox" name="fEvtBldRunNumberMin">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
                     <property name="maximum">
-                     <number>999999999</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="1" column="3">
-                   <widget class="QSpinBox" name="fEvtBldRunNumberMax">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>999999999</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="2">
-                   <widget class="QSpinBox" name="spinBox_6">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>999999999</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="2">
-                   <widget class="QSpinBox" name="spinBox_8">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>999999999</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="3">
-                   <widget class="QSpinBox" name="fEvtsEventId">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>999999999</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="0" column="2">
-                   <widget class="QLabel" name="label_110">
-                    <property name="text">
-                     <string>Min</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="0" column="3">
-                   <widget class="QLabel" name="label_127">
-                    <property name="text">
-                     <string>Max</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="3">
-                   <widget class="QSpinBox" name="fEvtsTriggerId">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>999999999</number>
-                    </property>
-                   </widget>
-                  </item>
-                 </layout>
-                </widget>
-               </widget>
-              </item>
-              <item row="1" column="0">
-               <widget class="QGroupBox" name="groupBox_18">
-                <property name="title">
-                 <string>Ethernet and memory</string>
-                </property>
-                <widget class="QWidget" name="gridLayoutWidget_6">
-                 <property name="geometry">
-                  <rect>
-                   <x>50</x>
-                   <y>60</y>
-                   <width>361</width>
-                   <height>126</height>
-                  </rect>
-                 </property>
-                 <layout class="QGridLayout" name="gridLayout_48" columnstretch="0,0,0,0,0">
-                  <item row="4" column="2" colspan="2">
-                   <widget class="QProgressBar" name="fFadBuffer">
-                    <property name="value">
-                     <number>24</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="2">
-                   <widget class="QDoubleSpinBox" name="doubleSpinBox_4">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="1" column="2">
-                   <widget class="QDoubleSpinBox" name="doubleSpinBox_5">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="2">
-                   <widget class="QDoubleSpinBox" name="doubleSpinBox_6">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="1" column="1">
-                   <widget class="QLabel" name="label_118">
-                    <property name="text">
-                     <string>Min</string>
-                    </property>
-                    <property name="alignment">
-                     <set>Qt::AlignCenter</set>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="1">
-                   <widget class="QLabel" name="label_119">
-                    <property name="text">
-                     <string>Avg</string>
-                    </property>
-                    <property name="alignment">
-                     <set>Qt::AlignCenter</set>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="1">
-                   <widget class="QLabel" name="label_122">
-                    <property name="text">
-                     <string>Max</string>
-                    </property>
-                    <property name="alignment">
-                     <set>Qt::AlignCenter</set>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="4" column="1">
-                   <widget class="QLabel" name="label_124">
-                    <property name="text">
-                     <string>Buffer</string>
-                    </property>
-                    <property name="alignment">
-                     <set>Qt::AlignCenter</set>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="0" column="1" colspan="3">
-                   <widget class="QLabel" name="label_117">
-                    <property name="text">
-                     <string>Ethernet throughput per socket</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="1" column="3">
-                   <widget class="QLabel" name="label_123">
-                    <property name="text">
-                     <string>Total</string>
-                    </property>
-                    <property name="alignment">
-                     <set>Qt::AlignCenter</set>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="4" column="4">
-                   <widget class="QSpinBox" name="fFadBufferMax">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="suffix">
-                     <string> MB</string>
-                    </property>
-                    <property name="maximum">
-                     <number>1000000</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="3">
-                   <widget class="QSpinBox" name="fFadEvtRead">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="suffix">
-                     <string> kB/s</string>
-                    </property>
-                    <property name="maximum">
-                     <number>1000000</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="4">
-                   <widget class="QLabel" name="label_105">
-                    <property name="text">
-                     <string>Maximum buffer size</string>
-                    </property>
-                    <property name="alignment">
-                     <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
-                    </property>
-                   </widget>
-                  </item>
-                 </layout>
-                </widget>
-               </widget>
-              </item>
-              <item row="0" column="0">
-               <widget class="QGroupBox" name="groupBox_17">
-                <property name="title">
-                 <string>Processing statistics</string>
-                </property>
-                <widget class="QWidget" name="gridLayoutWidget_4">
-                 <property name="geometry">
-                  <rect>
-                   <x>60</x>
-                   <y>40</y>
-                   <width>361</width>
-                   <height>160</height>
-                  </rect>
-                 </property>
-                 <layout class="QGridLayout" name="gridLayout_49">
-                  <item row="0" column="0">
-                   <widget class="QLabel" name="label_140">
-                    <property name="text">
-                     <string>Incomplete events in buffer</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="1" column="0">
-                   <widget class="QLabel" name="label_139">
-                    <property name="text">
-                     <string>Completed events ready for writing</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="0">
-                   <widget class="QLabel" name="label_141">
-                    <property name="text">
-                     <string>No of events removed from buffer (1s)</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="0">
-                   <widget class="QLabel" name="label_142">
-                    <property name="text">
-                     <string>No of events removed from buffer (tot)</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="4" column="0">
-                   <widget class="QLabel" name="label_144">
-                    <property name="text">
-                     <string>Connections (open sockets)</string>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="0" column="1">
-                   <widget class="QSpinBox" name="fFadEvtWait">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>10000000</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="1" column="1">
-                   <widget class="QSpinBox" name="fFadEvtSkip">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>10000000</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="2" column="1">
-                   <widget class="QSpinBox" name="fFadEvtDel">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>10000000</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="3" column="1">
-                   <widget class="QSpinBox" name="fFadEvtTot">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>10000000</number>
-                    </property>
-                   </widget>
-                  </item>
-                  <item row="4" column="1">
-                   <widget class="QSpinBox" name="fFadEvtConn">
-                    <property name="alignment">
-                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                    </property>
-                    <property name="readOnly">
-                     <bool>true</bool>
-                    </property>
-                    <property name="buttonSymbols">
-                     <enum>QAbstractSpinBox::NoButtons</enum>
-                    </property>
-                    <property name="maximum">
-                     <number>10000000</number>
+                     <number>2147483647</number>
                     </property>
                    </widget>
@@ -5081,5 +5134,5 @@
            <string>Event Builder overview</string>
           </property>
-          <widget class="QWidget" name="fAdcWidget_2">
+          <widget class="QWidget" name="fAdcWidget">
            <property name="sizePolicy">
             <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
@@ -6930,6 +6983,6 @@
    <property name="minimumSize">
     <size>
-     <width>223</width>
-     <height>349</height>
+     <width>230</width>
+     <height>403</height>
     </size>
    </property>
@@ -7034,151 +7087,4 @@
         </widget>
        </item>
-       <item row="4" column="4">
-        <widget class="QLabel" name="fStatusFADLabel">
-         <property name="text">
-          <string>Offline</string>
-         </property>
-        </widget>
-       </item>
-       <item row="4" column="3">
-        <widget class="QPushButton" name="fStatusFADLed">
-         <property name="enabled">
-          <bool>true</bool>
-         </property>
-         <property name="sizePolicy">
-          <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-           <horstretch>0</horstretch>
-           <verstretch>0</verstretch>
-          </sizepolicy>
-         </property>
-         <property name="maximumSize">
-          <size>
-           <width>18</width>
-           <height>16777215</height>
-          </size>
-         </property>
-         <property name="text">
-          <string/>
-         </property>
-         <property name="icon">
-          <iconset resource="design.qrc">
-           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-         </property>
-         <property name="iconSize">
-          <size>
-           <width>16</width>
-           <height>16</height>
-          </size>
-         </property>
-         <property name="checkable">
-          <bool>false</bool>
-         </property>
-         <property name="flat">
-          <bool>true</bool>
-         </property>
-        </widget>
-       </item>
-       <item row="4" column="1">
-        <widget class="QCheckBox" name="fStatusFADEnable">
-         <property name="enabled">
-          <bool>false</bool>
-         </property>
-         <property name="sizePolicy">
-          <sizepolicy hsizetype="Minimum" vsizetype="Minimum">
-           <horstretch>0</horstretch>
-           <verstretch>0</verstretch>
-          </sizepolicy>
-         </property>
-         <property name="maximumSize">
-          <size>
-           <width>20</width>
-           <height>16777215</height>
-          </size>
-         </property>
-         <property name="text">
-          <string/>
-         </property>
-         <property name="checked">
-          <bool>true</bool>
-         </property>
-        </widget>
-       </item>
-       <item row="9" column="4">
-        <widget class="QLabel" name="fStatusChatLabel">
-         <property name="text">
-          <string>Offline</string>
-         </property>
-        </widget>
-       </item>
-       <item row="8" column="1">
-        <widget class="QCheckBox" name="fStatusLoggerEnable">
-         <property name="enabled">
-          <bool>false</bool>
-         </property>
-         <property name="sizePolicy">
-          <sizepolicy hsizetype="Minimum" vsizetype="Minimum">
-           <horstretch>0</horstretch>
-           <verstretch>0</verstretch>
-          </sizepolicy>
-         </property>
-         <property name="maximumSize">
-          <size>
-           <width>20</width>
-           <height>16777215</height>
-          </size>
-         </property>
-         <property name="text">
-          <string/>
-         </property>
-         <property name="checked">
-          <bool>true</bool>
-         </property>
-        </widget>
-       </item>
-       <item row="8" column="3">
-        <widget class="QPushButton" name="fStatusLoggerLed">
-         <property name="enabled">
-          <bool>true</bool>
-         </property>
-         <property name="sizePolicy">
-          <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-           <horstretch>0</horstretch>
-           <verstretch>0</verstretch>
-          </sizepolicy>
-         </property>
-         <property name="maximumSize">
-          <size>
-           <width>18</width>
-           <height>16777215</height>
-          </size>
-         </property>
-         <property name="text">
-          <string/>
-         </property>
-         <property name="icon">
-          <iconset resource="design.qrc">
-           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-         </property>
-         <property name="iconSize">
-          <size>
-           <width>16</width>
-           <height>16</height>
-          </size>
-         </property>
-         <property name="checkable">
-          <bool>false</bool>
-         </property>
-         <property name="flat">
-          <bool>true</bool>
-         </property>
-        </widget>
-       </item>
-       <item row="8" column="4">
-        <widget class="QLabel" name="fStatusLoggerLabel">
-         <property name="text">
-          <string>Offline</string>
-         </property>
-        </widget>
-       </item>
        <item row="2" column="0" colspan="6">
         <widget class="Line" name="line">
@@ -7207,61 +7113,4 @@
         </widget>
        </item>
-       <item row="4" column="2">
-        <widget class="QLabel" name="fStatusFAD">
-         <property name="sizePolicy">
-          <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
-           <horstretch>0</horstretch>
-           <verstretch>0</verstretch>
-          </sizepolicy>
-         </property>
-         <property name="toolTip">
-          <string>Data acquisition (DRS4 readou)</string>
-         </property>
-         <property name="text">
-          <string>FAD</string>
-         </property>
-         <property name="alignment">
-          <set>Qt::AlignCenter</set>
-         </property>
-        </widget>
-       </item>
-       <item row="8" column="2">
-        <widget class="QLabel" name="fStatusLogger">
-         <property name="sizePolicy">
-          <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
-           <horstretch>0</horstretch>
-           <verstretch>0</verstretch>
-          </sizepolicy>
-         </property>
-         <property name="toolTip">
-          <string>Data Logger (writes slow control files)</string>
-         </property>
-         <property name="text">
-          <string>Logger</string>
-         </property>
-         <property name="alignment">
-          <set>Qt::AlignCenter</set>
-         </property>
-        </widget>
-       </item>
-       <item row="9" column="2">
-        <widget class="QLabel" name="fStatusChat">
-         <property name="sizePolicy">
-          <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
-           <horstretch>0</horstretch>
-           <verstretch>0</verstretch>
-          </sizepolicy>
-         </property>
-         <property name="toolTip">
-          <string>Chat server</string>
-         </property>
-         <property name="text">
-          <string>Chat</string>
-         </property>
-         <property name="alignment">
-          <set>Qt::AlignCenter</set>
-         </property>
-        </widget>
-       </item>
        <item row="1" column="2">
         <widget class="QLabel" name="fStatusDNS">
@@ -7296,5 +7145,43 @@
         </spacer>
        </item>
-       <item row="5" column="2">
+       <item row="1" column="3">
+        <widget class="QPushButton" name="fStatusDNSLed">
+         <property name="enabled">
+          <bool>true</bool>
+         </property>
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="maximumSize">
+          <size>
+           <width>18</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="icon">
+          <iconset resource="design.qrc">
+           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+         </property>
+         <property name="iconSize">
+          <size>
+           <width>16</width>
+           <height>16</height>
+          </size>
+         </property>
+         <property name="checkable">
+          <bool>false</bool>
+         </property>
+         <property name="flat">
+          <bool>true</bool>
+         </property>
+        </widget>
+       </item>
+       <item row="4" column="2">
         <widget class="QLabel" name="label_59">
          <property name="sizePolicy">
@@ -7312,26 +7199,255 @@
         </widget>
        </item>
-       <item row="5" column="4">
-        <widget class="QLabel" name="fStatusFTULabel">
+       <item row="5" column="2">
+        <widget class="QLabel" name="fStatusFAD">
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="toolTip">
+          <string>Data acquisition (DRS4 readou)</string>
+         </property>
          <property name="text">
-          <string>Offline</string>
+          <string>FAD</string>
+         </property>
+         <property name="alignment">
+          <set>Qt::AlignCenter</set>
+         </property>
+        </widget>
+       </item>
+       <item row="6" column="2">
+        <widget class="QLabel" name="label_124">
+         <property name="text">
+          <string>Event builder</string>
+         </property>
+         <property name="alignment">
+          <set>Qt::AlignCenter</set>
          </property>
         </widget>
        </item>
        <item row="7" column="2">
+        <widget class="QLabel" name="label_135">
+         <property name="text">
+          <string>Slow Control</string>
+         </property>
+        </widget>
+       </item>
+       <item row="8" column="2">
         <widget class="QLabel" name="label_60">
          <property name="text">
           <string>Scheduler</string>
          </property>
+         <property name="alignment">
+          <set>Qt::AlignCenter</set>
+         </property>
         </widget>
        </item>
-       <item row="7" column="4">
-        <widget class="QLabel" name="fStatusSchedulerLabel">
+       <item row="9" column="2">
+        <widget class="QLabel" name="fStatusLogger">
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="toolTip">
+          <string>Data Logger (writes slow control files)</string>
+         </property>
          <property name="text">
-          <string>Offline</string>
+          <string>Logger</string>
+         </property>
+         <property name="alignment">
+          <set>Qt::AlignCenter</set>
+         </property>
+        </widget>
+       </item>
+       <item row="10" column="2">
+        <widget class="QLabel" name="fStatusChat">
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="toolTip">
+          <string>Chat server</string>
+         </property>
+         <property name="text">
+          <string>Chat</string>
+         </property>
+         <property name="alignment">
+          <set>Qt::AlignCenter</set>
+         </property>
+        </widget>
+       </item>
+       <item row="9" column="1">
+        <widget class="QCheckBox" name="fStatusLoggerEnable">
+         <property name="enabled">
+          <bool>false</bool>
+         </property>
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Minimum" vsizetype="Minimum">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="maximumSize">
+          <size>
+           <width>20</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="checked">
+          <bool>true</bool>
+         </property>
+        </widget>
+       </item>
+       <item row="5" column="1">
+        <widget class="QCheckBox" name="fStatusFADEnable">
+         <property name="enabled">
+          <bool>false</bool>
+         </property>
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Minimum" vsizetype="Minimum">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="maximumSize">
+          <size>
+           <width>20</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="checked">
+          <bool>true</bool>
+         </property>
+        </widget>
+       </item>
+       <item row="4" column="3">
+        <widget class="QPushButton" name="fStatusFTULed">
+         <property name="maximumSize">
+          <size>
+           <width>18</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="icon">
+          <iconset resource="design.qrc">
+           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+         </property>
+         <property name="flat">
+          <bool>true</bool>
+         </property>
+        </widget>
+       </item>
+       <item row="5" column="3">
+        <widget class="QPushButton" name="fStatusFADLed">
+         <property name="enabled">
+          <bool>true</bool>
+         </property>
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="maximumSize">
+          <size>
+           <width>18</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="icon">
+          <iconset resource="design.qrc">
+           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+         </property>
+         <property name="iconSize">
+          <size>
+           <width>16</width>
+           <height>16</height>
+          </size>
+         </property>
+         <property name="checkable">
+          <bool>false</bool>
+         </property>
+         <property name="flat">
+          <bool>true</bool>
+         </property>
+        </widget>
+       </item>
+       <item row="6" column="3">
+        <widget class="QPushButton" name="fStatusEventBuilderLed">
+         <property name="enabled">
+          <bool>true</bool>
+         </property>
+         <property name="sizePolicy">
+          <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
+           <horstretch>0</horstretch>
+           <verstretch>0</verstretch>
+          </sizepolicy>
+         </property>
+         <property name="maximumSize">
+          <size>
+           <width>18</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="icon">
+          <iconset resource="design.qrc">
+           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+         </property>
+         <property name="iconSize">
+          <size>
+           <width>16</width>
+           <height>16</height>
+          </size>
+         </property>
+         <property name="checkable">
+          <bool>false</bool>
+         </property>
+         <property name="flat">
+          <bool>true</bool>
          </property>
         </widget>
        </item>
        <item row="7" column="3">
+        <widget class="QPushButton" name="fStatusFSCLed">
+         <property name="maximumSize">
+          <size>
+           <width>18</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="icon">
+          <iconset resource="design.qrc">
+           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+         </property>
+         <property name="flat">
+          <bool>true</bool>
+         </property>
+        </widget>
+       </item>
+       <item row="8" column="3">
         <widget class="QPushButton" name="fStatusSchedulerLed">
          <property name="maximumSize">
@@ -7354,5 +7470,5 @@
        </item>
        <item row="9" column="3">
-        <widget class="QPushButton" name="fStatusChatLed">
+        <widget class="QPushButton" name="fStatusLoggerLed">
          <property name="enabled">
           <bool>true</bool>
@@ -7391,6 +7507,6 @@
         </widget>
        </item>
-       <item row="1" column="3">
-        <widget class="QPushButton" name="fStatusDNSLed">
+       <item row="10" column="3">
+        <widget class="QPushButton" name="fStatusChatLed">
          <property name="enabled">
           <bool>true</bool>
@@ -7429,12 +7545,26 @@
         </widget>
        </item>
-       <item row="6" column="2">
-        <widget class="QLabel" name="label_135">
+       <item row="4" column="4">
+        <widget class="QLabel" name="fStatusFTULabel">
          <property name="text">
-          <string>Slow Control</string>
+          <string>Offline</string>
+         </property>
+        </widget>
+       </item>
+       <item row="5" column="4">
+        <widget class="QLabel" name="fStatusFADLabel">
+         <property name="text">
+          <string>Offline</string>
          </property>
         </widget>
        </item>
        <item row="6" column="4">
+        <widget class="QLabel" name="fStatusEventBuilderLabel">
+         <property name="text">
+          <string>Offline</string>
+         </property>
+        </widget>
+       </item>
+       <item row="7" column="4">
         <widget class="QLabel" name="fStatusFSCLabel">
          <property name="text">
@@ -7443,41 +7573,22 @@
         </widget>
        </item>
-       <item row="5" column="3">
-        <widget class="QPushButton" name="fStatusFTULed">
-         <property name="maximumSize">
-          <size>
-           <width>18</width>
-           <height>16777215</height>
-          </size>
-         </property>
+       <item row="8" column="4">
+        <widget class="QLabel" name="fStatusSchedulerLabel">
          <property name="text">
-          <string/>
-         </property>
-         <property name="icon">
-          <iconset resource="design.qrc">
-           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-         </property>
-         <property name="flat">
-          <bool>true</bool>
+          <string>Offline</string>
          </property>
         </widget>
        </item>
-       <item row="6" column="3">
-        <widget class="QPushButton" name="fStatusFSCLed">
-         <property name="maximumSize">
-          <size>
-           <width>18</width>
-           <height>16777215</height>
-          </size>
-         </property>
+       <item row="9" column="4">
+        <widget class="QLabel" name="fStatusLoggerLabel">
          <property name="text">
-          <string/>
-         </property>
-         <property name="icon">
-          <iconset resource="design.qrc">
-           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-         </property>
-         <property name="flat">
-          <bool>true</bool>
+          <string>Offline</string>
+         </property>
+        </widget>
+       </item>
+       <item row="10" column="4">
+        <widget class="QLabel" name="fStatusChatLabel">
+         <property name="text">
+          <string>Offline</string>
          </property>
         </widget>
